import usb, pygame, sys, os,random
from pygame.locals import *
sw=0
sw2=0
speed = 1
lightvalue=0
####################################
VENDOR_RQ_SET_LED    = 0
VENDOR_RQ_GET_SWITCH = 1
VENDOR_RQ_GET_LIGHT  = 2

####################################
filename = "highscore.txt"


class Board:
    def __init__(self):
        #print "Looking for MCU board..."
        dev = self.find_board()
        if not dev: raise "MCU board not found!"
        #print "MCU board found"
        self.handle = dev.open()

    def find_board(self):
        for bus in usb.busses():
            for dev in bus.devices:
                if dev.idVendor == 0x16c0 and dev.idProduct == 0x05dc:
                    return dev
        return None

    def set_led(self,pin,val):
        reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_OUT
        self.handle.controlMsg(reqType, VENDOR_RQ_SET_LED, None, value=val*256+pin,timeout=100000)

    def get_switch(self):
        reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
        buf = self.handle.controlMsg(reqType, VENDOR_RQ_GET_SWITCH, 1,timeout=100000)
        return buf[0]

    def get_light(self):
        reqType = usb.TYPE_VENDOR | usb.RECIP_DEVICE | usb.ENDPOINT_IN
        buf = self.handle.controlMsg(reqType, VENDOR_RQ_GET_LIGHT, 2,timeout = 100000)
        #lightvalue=buf[1]*256+buf[0]
        return buf[1]*256+buf[0]

from board import Board
board = Board()
running = 1

while running:
	FILE = open(filename,"r")
	highscore = int(FILE.readline())
	FILE.close()
	FILE4 = open("name.txt","r")
	highname = str(FILE4.readline())
	FILE4.close()
	board.set_led(0,0)
	board.set_led(1,1)
	pygame.init()
	pygame.font.init()
	font = pygame.font.Font(None, 60)
	window = pygame.display.set_mode((800,600))
	pygame.display.set_caption('Practicum')
	screen = pygame.display.get_surface()
	picturename = "ball.png"
	picture_surface = pygame.image.load(picturename)
	background = pygame.image.load("bg.png")
	welcomebg = pygame.image.load("practicum_bg.png")
	screen.blit(welcomebg, (0,0))
	pygame.display.update()
	light = board.get_light()
	if board.get_switch()==0: 
		print board.get_light()
		board.set_led(0,1)
		board.set_led(1,0)
		pygame.time.delay(1000)
		countdown5 = font.render('5', False,(255,255,255))
		screen.blit(background, (0,0))
		screen.blit(countdown5, (370,310))
		screen.blit(picture_surface, (0,0))
		pygame.display.update()
		pygame.time.delay(1000)
		countdown4 = font.render('4', False,(255,255,255))
		screen.blit(background, (0,0))
		screen.blit(countdown4, (370,310))
		screen.blit(picture_surface, (0,0))
		pygame.display.update()
		pygame.time.delay(1000)
		countdown3 = font.render('3', False,(255,255,255))
		screen.blit(background, (0,0))
		screen.blit(countdown3, (370,310))
		screen.blit(picture_surface, (0,0))
		pygame.display.update()
		pygame.time.delay(1000)
		countdown2 = font.render('2', False,(255,255,255))
		screen.blit(background, (0,0))
		screen.blit(countdown2, (370,310))
		screen.blit(picture_surface, (0,0))
		pygame.display.update()
		pygame.time.delay(1000)
		countdown1 = font.render('1', False,(255,255,255))
		screen.blit(background, (0,0))
		screen.blit(countdown1, (370,310))
		screen.blit(picture_surface, (0,0))
		pygame.display.update()
		pygame.time.delay(1000)
		screen.blit(background, (0,0))
		screen.blit(picture_surface, (0,0))
		pygame.display.update()
		maxlight = board.get_light()+100
		minlight = board.get_light()-100
		position = picture_surface.get_rect()
		destinationx = random.randint(0,350)
		destinationy = random.randint(50,250)
		currentx = 0
		currenty = 0
		movex = 0
		movey = 0
		count = 0
		k = 300
		delay_time = 10
		font = pygame.font.Font(None, 29)
		while(light>minlight and light<maxlight):
			count = count+1
			light = board.get_light()
		
			time = str(pygame.time.get_ticks()/1000)
			screen.blit(background, position, position)
			screen.blit(background, (660,10))
			score = font.render(str(count), False, (255,255,255))
			time_text = font.render('score: ', False, (225,112,34),(0,0,0,0))
			highscoretx = font.render('Highscore: %d' %highscore, False, (255,255,255)) 
			highscorename = font.render('By: %s' %highname, False, (255,255,255))
			screen.blit(score, (680, 10))
			screen.blit(time_text, (600,10))
			screen.blit(highscoretx, (600,30))
			screen.blit(highscorename, (600,50))
			if pygame.time.get_ticks()%300==0:
				delay_time = delay_time-2
    
			if currenty == destinationy and currentx == destinationx:
				destinationx = random.randint(0,350)
				destinationy = random.randint(40,250)
			if(count>1200 and count%k==0):
				destinationx = random.randint(0,350)
				destinationy = random.randint(40,250)   
				if k<20:
					k = 10
				else: 
					k = k - 10
                    
			if destinationx==currentx:
				movex = 0
			elif destinationx>currentx:
				currentx = currentx+1
				movex = 2
			elif destinationx<currentx:
				currentx = currentx-1
				movex = -2
			if destinationy==currenty:
				movey = 0
			elif destinationy>currenty:
				currenty = currenty+1
				movey = 2
			elif destinationy<currenty:
				currenty = currenty-1
				movey = -2

			position = position.move(movex,movey)
			for event in pygame.event.get(): 
				if event.type == pygame.QUIT: 
					running = 0
					board.set_led(0,0)
					board.set_led(1,1)

    
			screen.blit(picture_surface, position)
			pygame.display.update()
			pygame.time.delay(delay_time)
		loose = font.render('You Loose', False, (255,255,255))
		score = font.render('Your score = %d' %count, False, (225,112,34))
		screen.blit(background,(0,0))
		screen.blit(loose, (330,240))    
		screen.blit(score, (300,280))
		if count>highscore:
			FILE2 = open(filename,"w")
			FILE2.write(str(count))
			FILE2.close()
			text2 = font.render('You got HIGHSCORE!!',False,(255,0,0))
			screen.blit(text2,(280,310))
			inputname = font.render('Type your name on Command Line', False, (255,255,255))
			screen.blit(inputname, (220,340))
			pygame.display.update()
			print "Type in your name"
			FILE3 = open("name.txt","w")
			FILE3.write(raw_input())
			FILE3.close()
		pygame.display.update()
		pygame.time.delay(3000)
 
    


